class IntelHex

	attr_accessor :intelhex
	attr_accessor :object

	def initialize
		@intelhex = Array.new
		@object = Hash.new
	end

	def encode_hex(object = @object)
		@intelhex = Array.new
		c_adr = -1
		object.keys.sort.each {|adr|
			if(c_adr != (adr_h = adr >> 16) and dat = [adr_h >> 8, adr_h & 0xFF] and c_adr = adr_h)
				dat.unshift(dat.size, 0, 0, 4)
				sum = 0; dat.each {|c| sum += c }; sum %= 0x100
				dat.push(0x100 - sum)
				@intelhex << ':' + dat.pack('C*').unpack('H*')[0].upcase
			end
			pt = -16; while(dat = object[adr].slice(pt += 16, 16) and dat.size > 0)
				dat.unshift(dat.size, adr + pt >> 8, adr + pt & 0xFF, 0)
				sum = 0; dat.each {|c| sum += c }; sum %= 0x100
				dat.push(0x100 - sum)
				@intelhex << ':' + dat.pack('C*').unpack('H*')[0].upcase
			end
		}
		@intelhex << ':00000001FF'
	end

	def decode_hex(intelhex = @intelhex)
		@object = Hash.new; @esa_adr = @ela_adr = 0
		adr = nil; intelhex.each {|l|
			break unless(dat = parse_hex(l.strip))
			dat[1] == 2 and @esa_adr = ((dat[2][0] << 12) + dat[2][1]) <<  4
			dat[1] == 4 and @ela_adr = ((dat[2][0] << 24) + dat[2][1]) << 16
			next if(dat.size == 0 or dat[1] != 0)
			if(adr and adr + @object[adr].size == dat[0] + @esa_adr + @ela_adr)
				@object[adr] += dat[2]
			else
				@object[adr = dat[0] + @esa_adr + @ela_adr] = dat[2]
			end
		}
	end

	def parse_hex(l)
		if(l =~ /^\s*$/ or l =~ /^#/)
			return [] 
		elsif(l =~ /^:([0-9A-Z]{2})([0-9A-Z]{4})([0-9A-Z]{2})([0-9A-Z]*)([0-9A-Z]{2})$/)
			rlen = $1; radr = $2; rtype = $3; rdat = $4; rsum = $5
			# check len
			raise "length error[#{l}]" unless(rlen.to_i(16) == rdat.length / 2)
			# check sum
			dat = [rlen + radr + rtype + rdat + rsum].pack('H*').unpack('C*')
			sum = 0; dat.each {|c| sum += c }; sum %= 0x100
			raise "checksum error[#{l}]" unless(sum == 0)
			# end check
			return nil if(rlen == '00' and rtype == '01')
			# store dat
			return radr.to_i(16), rtype.to_i(16), [rdat].pack('H*').unpack('C*')
		else
			raise "format error[#{l}]"
		end
	end

	def alignment(orgs, null = 0xFF)
		orgs.each {|p|
			@object[p] = [] unless(@object.include?(p))
		}
		pb = @object.keys.min
		@object.keys.sort.each {|p|
			if(orgs.include?(p))
				pb = p
			else
				sp = p - (pb + @object[pb].size)
				(0...sp).each {|n|
					@object[pb] << null
				}
				@object[pb] += @object[p]; @object.delete(p)
			end
		}
	end
end

__END__

